require '_h2ph_pre.ph';

unless(defined(&__ASM_ATOMIC_H)) {
    eval 'sub __ASM_ATOMIC_H () {1;}' unless defined(&__ASM_ATOMIC_H);
    require 'linux/config.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub ATOMIC_INIT {
	    local($i) = @_;
    	    eval q({ ($i) });
	}' unless defined(&ATOMIC_INIT);
	eval 'sub atomic_read {
	    local($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic_read);
	eval 'sub atomic_set {
	    local($v,$i) = @_;
    	    eval q((($v)-> &counter = ($i)));
	}' unless defined(&atomic_set);
	if(!defined( &CONFIG_CPU_HAS_LLSC)) {
	    require 'asm/system.ph';
	} else {
	}
	eval 'sub atomic_dec_return {
	    local($v) = @_;
    	    eval q( &atomic_sub_return(1,($v)));
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_inc_return {
	    local($v) = @_;
    	    eval q( &atomic_add_return(1,($v)));
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic_sub_and_test {
	    local($i,$v) = @_;
    	    eval q(( &atomic_sub_return(($i), ($v)) == 0));
	}' unless defined(&atomic_sub_and_test);
	eval 'sub atomic_dec_and_test {
	    local($v) = @_;
    	    eval q(( &atomic_sub_return(1, ($v)) == 0));
	}' unless defined(&atomic_dec_and_test);
	eval 'sub atomic_inc {
	    local($v) = @_;
    	    eval q( &atomic_add(1,($v)));
	}' unless defined(&atomic_inc);
	eval 'sub atomic_dec {
	    local($v) = @_;
    	    eval q( &atomic_sub(1,($v)));
	}' unless defined(&atomic_dec);
    }
}
1;
