require '_h2ph_pre.ph';

unless(defined(&_ASM_FLOPPY_H)) {
    eval 'sub _ASM_FLOPPY_H () {1;}' unless defined(&_ASM_FLOPPY_H);
    require 'asm/bootinfo.ph';
    require 'asm/jazz.ph';
    require 'asm/jazzdma.ph';
    eval 'sub fd_inb {
        local($port) = @_;
	    eval q( ($fd_ops->{fd_inb})($port));
    }' unless defined(&fd_inb);
    eval 'sub fd_outb {
        local($value,$port) = @_;
	    eval q( ($fd_ops->{fd_outb})($value,$port));
    }' unless defined(&fd_outb);
    eval 'sub fd_enable_dma () {
        eval q( ($fd_ops->{fd_enable_dma})( &FLOPPY_DMA));
    }' unless defined(&fd_enable_dma);
    eval 'sub fd_disable_dma () {
        eval q( ($fd_ops->{fd_disable_dma})( &FLOPPY_DMA));
    }' unless defined(&fd_disable_dma);
    eval 'sub fd_request_dma () {
        eval q( ($fd_ops->{fd_request_dma})( &FLOPPY_DMA));
    }' unless defined(&fd_request_dma);
    eval 'sub fd_free_dma () {
        eval q( ($fd_ops->{fd_free_dma})( &FLOPPY_DMA));
    }' unless defined(&fd_free_dma);
    eval 'sub fd_clear_dma_ff () {
        eval q( ($fd_ops->{fd_clear_dma_ff})( &FLOPPY_DMA));
    }' unless defined(&fd_clear_dma_ff);
    eval 'sub fd_set_dma_mode {
        local($mode) = @_;
	    eval q( ($fd_ops->{fd_set_dma_mode})( &FLOPPY_DMA, $mode));
    }' unless defined(&fd_set_dma_mode);
    eval 'sub fd_set_dma_addr {
        local($addr) = @_;
	    eval q( ($fd_ops->{fd_set_dma_addr})( &FLOPPY_DMA,  &virt_to_bus($addr)));
    }' unless defined(&fd_set_dma_addr);
    eval 'sub fd_set_dma_count {
        local($count) = @_;
	    eval q( ($fd_ops->{fd_set_dma_count})( &FLOPPY_DMA,$count));
    }' unless defined(&fd_set_dma_count);
    eval 'sub fd_get_dma_residue () {
        eval q( ($fd_ops->{fd_get_dma_residue})( &FLOPPY_DMA));
    }' unless defined(&fd_get_dma_residue);
    eval 'sub fd_enable_irq () {
        eval q( ($fd_ops->{fd_enable_irq})( &FLOPPY_IRQ));
    }' unless defined(&fd_enable_irq);
    eval 'sub fd_disable_irq () {
        eval q( ($fd_ops->{fd_disable_irq})( &FLOPPY_IRQ));
    }' unless defined(&fd_disable_irq);
    eval 'sub fd_request_irq () {
        eval q( &request_irq( &FLOPPY_IRQ,  &floppy_interrupt,  &SA_INTERRUPT |  &SA_SAMPLE_RANDOM, \\"floppy\\",  &NULL));
    }' unless defined(&fd_request_irq);
    eval 'sub fd_free_irq () {
        eval q( &free_irq( &FLOPPY_IRQ,  &NULL););
    }' unless defined(&fd_free_irq);
    eval 'sub fd_dma_mem_alloc {
        local($size) = @_;
	    eval q( ($fd_ops->{fd_dma_mem_alloc})($size));
    }' unless defined(&fd_dma_mem_alloc);
    eval 'sub fd_dma_mem_free {
        local($mem,$size) = @_;
	    eval q( ($fd_ops->{fd_dma_mem_free})($mem,$size));
    }' unless defined(&fd_dma_mem_free);
    eval 'sub fd_drive_type {
        local($n) = @_;
	    eval q( ($fd_ops->{fd_drive_type})($n));
    }' unless defined(&fd_drive_type);
    eval 'sub fd_cacheflush {
        local($addr,$size) = @_;
	    eval q( &dma_cache_wback_inv($addr,$size));
    }' unless defined(&fd_cacheflush);
    eval 'sub MAX_BUFFER_SECTORS () {24;}' unless defined(&MAX_BUFFER_SECTORS);
    eval 'sub FLOPPY0_TYPE () { &fd_drive_type(0);}' unless defined(&FLOPPY0_TYPE);
    eval 'sub FLOPPY1_TYPE () { &fd_drive_type(1);}' unless defined(&FLOPPY1_TYPE);
    eval 'sub FDC1 () { ($fd_ops->{fd_getfdaddr1})();;}' unless defined(&FDC1);
    if(defined(&FDPATCHES)) {
    }
    eval 'sub N_FDC () {1;}' unless defined(&N_FDC);
    eval 'sub N_DRIVE () {8;}' unless defined(&N_DRIVE);
    eval 'sub FLOPPY_MOTOR_MASK () {0xf0;}' unless defined(&FLOPPY_MOTOR_MASK);
    eval 'sub CROSS_64KB {
        local($a,$s) = @_;
	    eval q((/ &K_64 != (($a) + ($s) - 1) /  &K_64));
    }' unless defined(&CROSS_64KB);
}
1;
