require '_h2ph_pre.ph';

unless(defined(&_ASM_MC146818RTC_H)) {
    eval 'sub _ASM_MC146818RTC_H () {1;}' unless defined(&_ASM_MC146818RTC_H);
    require 'linux/config.ph';
    require 'asm/io.ph';
    unless(defined(&RTC_PORT)) {
	eval 'sub RTC_PORT {
	    local($x) = @_;
    	    eval q((0x70 + ($x)));
	}' unless defined(&RTC_PORT);
    }
    eval 'sub CMOS_READ {
        local($addr) = @_;
	    eval q(({  ($rtc_ops->{rtc_read_data})($addr); }));
    }' unless defined(&CMOS_READ);
    eval 'sub CMOS_WRITE {
        local($val, $addr) = @_;
	    eval q(({  ($rtc_ops->{rtc_write_data})($val, $addr); }));
    }' unless defined(&CMOS_WRITE);
    eval 'sub RTC_ALWAYS_BCD () { ($rtc_ops->{rtc_bcd_mode})();}' unless defined(&RTC_ALWAYS_BCD);
    if(defined(&CONFIG_DECSTATION)) {
	eval 'sub RTC_IRQ () {0;}' unless defined(&RTC_IRQ);
    } else {
	eval 'sub RTC_IRQ () {8;}' unless defined(&RTC_IRQ);
    }
    eval 'sub RTC_DEC_YEAR () {0x3f;}' unless defined(&RTC_DEC_YEAR);
}
1;
