require '_h2ph_pre.ph';

unless(defined(&_ASM_PARAM_H)) {
    eval 'sub _ASM_PARAM_H () {1;}' unless defined(&_ASM_PARAM_H);
    unless(defined(&HZ)) {
	if(defined(&__KERNEL__)) {
	    if(defined(&_SYS_PARAM_H)) {
		die("Do\ not\ include\ \<asm\/param\.h\>\ with\ __KERNEL__\ defined\!");
	    }
	    require 'linux/config.ph';
	    if(defined(&CONFIG_DECSTATION)) {
		eval 'sub LOG_2_HZ () {7;}' unless defined(&LOG_2_HZ);
		eval 'sub HZ () {(1<<  &LOG_2_HZ);}' unless defined(&HZ);
		eval 'sub QUOTIENT () {((1 << (32-  &LOG_2_HZ)) * 100);}' unless defined(&QUOTIENT);
		eval 'sub hz_to_std {
		    local($a) = @_;
    		    eval q(({ \'unsigned int __res\'; \'unsigned long __lo\';  &__asm__(\\"multu\\\\t%2,%3\\\\n\\\\t\\" :\\"=h\\" ( &__res), \\"=l\\" ( &__lo) :\\"r\\" ($a),\\"r\\" ( &QUOTIENT)); ( &__typeof__($a))  &__res;}));
		}' unless defined(&hz_to_std);
	    } else {
		eval 'sub HZ () {100;}' unless defined(&HZ);
		eval 'sub hz_to_std {
		    local($a) = @_;
    		    eval q(($a));
		}' unless defined(&hz_to_std);
	    }
	} else {
	    eval 'sub HZ () {100;}' unless defined(&HZ);
	}
    }
    eval 'sub EXEC_PAGESIZE () {4096;}' unless defined(&EXEC_PAGESIZE);
    unless(defined(&NGROUPS)) {
	eval 'sub NGROUPS () {32;}' unless defined(&NGROUPS);
    }
    unless(defined(&NOGROUP)) {
	eval 'sub NOGROUP () {(-1);}' unless defined(&NOGROUP);
    }
    eval 'sub MAXHOSTNAMELEN () {64;}' unless defined(&MAXHOSTNAMELEN);
}
1;
