require '_h2ph_pre.ph';

unless(defined(&_SOCKETBITS_H)) {
    eval 'sub _SOCKETBITS_H () {1;}' unless defined(&_SOCKETBITS_H);
    require 'features.ph';
    eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
    eval 'sub __need_NULL () {1;}' unless defined(&__need_NULL);
    require 'stddef.ph';
    eval 'sub PF_UNSPEC () {0;}' unless defined(&PF_UNSPEC);
    eval 'sub PF_LOCAL () {1;}' unless defined(&PF_LOCAL);
    eval 'sub PF_UNIX () { &PF_LOCAL;}' unless defined(&PF_UNIX);
    eval 'sub PF_FILE () { &PF_LOCAL;}' unless defined(&PF_FILE);
    eval 'sub PF_INET () {2;}' unless defined(&PF_INET);
    eval 'sub PF_AX25 () {3;}' unless defined(&PF_AX25);
    eval 'sub PF_IPX () {4;}' unless defined(&PF_IPX);
    eval 'sub PF_APPLETALK () {5;}' unless defined(&PF_APPLETALK);
    eval 'sub PF_NETROM () {6;}' unless defined(&PF_NETROM);
    eval 'sub PF_BRIDGE () {7;}' unless defined(&PF_BRIDGE);
    eval 'sub PF_AAL5 () {8;}' unless defined(&PF_AAL5);
    eval 'sub PF_X25 () {9;}' unless defined(&PF_X25);
    eval 'sub PF_INET6 () {10;}' unless defined(&PF_INET6);
    eval 'sub PF_ROSE () {11;}' unless defined(&PF_ROSE);
    eval 'sub PF_DECnet () {12;}' unless defined(&PF_DECnet);
    eval 'sub PF_NETBEUI () {13;}' unless defined(&PF_NETBEUI);
    eval 'sub PF_SECURITY () {14;}' unless defined(&PF_SECURITY);
    eval 'sub pseudo_PF_KEY () {15;}' unless defined(&pseudo_PF_KEY);
    eval 'sub PF_NETLINK () {16;}' unless defined(&PF_NETLINK);
    eval 'sub PF_ROUTE () { &PF_NETLINK;}' unless defined(&PF_ROUTE);
    eval 'sub PF_PACKET () {17;}' unless defined(&PF_PACKET);
    eval 'sub PF_MAX () {32;}' unless defined(&PF_MAX);
    eval 'sub AF_UNSPEC () { &PF_UNSPEC;}' unless defined(&AF_UNSPEC);
    eval 'sub AF_LOCAL () { &PF_LOCAL;}' unless defined(&AF_LOCAL);
    eval 'sub AF_UNIX () { &PF_UNIX;}' unless defined(&AF_UNIX);
    eval 'sub AF_FILE () { &PF_FILE;}' unless defined(&AF_FILE);
    eval 'sub AF_INET () { &PF_INET;}' unless defined(&AF_INET);
    eval 'sub AF_AX25 () { &PF_AX25;}' unless defined(&AF_AX25);
    eval 'sub AF_IPX () { &PF_IPX;}' unless defined(&AF_IPX);
    eval 'sub AF_APPLETALK () { &PF_APPLETALK;}' unless defined(&AF_APPLETALK);
    eval 'sub AF_NETROM () { &PF_NETROM;}' unless defined(&AF_NETROM);
    eval 'sub AF_BRIDGE () { &PF_BRIDGE;}' unless defined(&AF_BRIDGE);
    eval 'sub AF_AAL5 () { &PF_AAL5;}' unless defined(&AF_AAL5);
    eval 'sub AF_X25 () { &PF_X25;}' unless defined(&AF_X25);
    eval 'sub AF_INET6 () { &PF_INET6;}' unless defined(&AF_INET6);
    eval 'sub AF_ROSE () { &PF_ROSE;}' unless defined(&AF_ROSE);
    eval 'sub AF_DECnet () { &PF_DECnet;}' unless defined(&AF_DECnet);
    eval 'sub AF_NETBEUI () { &PF_NETBEUI;}' unless defined(&AF_NETBEUI);
    eval 'sub AF_SECURITY () { &PF_SECURITY;}' unless defined(&AF_SECURITY);
    eval 'sub AF_KEY () { &pseudo_PF_KEY;}' unless defined(&AF_KEY);
    eval 'sub AF_NETLINK () { &PF_NETLINK;}' unless defined(&AF_NETLINK);
    eval 'sub AF_ROUTE () { &PF_ROUTE;}' unless defined(&AF_ROUTE);
    eval 'sub AF_PACKET () { &PF_PACKET;}' unless defined(&AF_PACKET);
    eval 'sub AF_MAX () { &PF_MAX;}' unless defined(&AF_MAX);
    eval 'sub SOL_IPV6 () {41;}' unless defined(&SOL_IPV6);
    eval 'sub SOL_ICMPV6 () {58;}' unless defined(&SOL_ICMPV6);
    eval 'sub SOL_RAW () {255;}' unless defined(&SOL_RAW);
    eval 'sub SOL_AX25 () {257;}' unless defined(&SOL_AX25);
    eval 'sub SOL_ATALK () {258;}' unless defined(&SOL_ATALK);
    eval 'sub SOL_NETROM () {259;}' unless defined(&SOL_NETROM);
    eval 'sub SOL_ROSE () {260;}' unless defined(&SOL_ROSE);
    eval 'sub SOL_DECNET () {261;}' unless defined(&SOL_DECNET);
    eval 'sub SOL_X25 () {262;}' unless defined(&SOL_X25);
    eval 'sub SOMAXCONN () {128;}' unless defined(&SOMAXCONN);
    require 'sockaddrcom.ph';
    if(!defined (defined(&__STRICT_ANSI__) ? &__STRICT_ANSI__ : 0)  && defined (defined(&__GNUC__) ? &__GNUC__ : 0)  && (defined(&__GNUC__) ? &__GNUC__ : 0) >= 2) {
    }
    if(!defined (defined(&__STRICT_ANSI__) ? &__STRICT_ANSI__ : 0)  && defined (defined(&__GNUC__) ? &__GNUC__ : 0)  && (defined(&__GNUC__) ? &__GNUC__ : 0) >= 2) {
	eval 'sub CMSG_DATA {
	    local($cmsg) = @_;
    	    eval q((($cmsg)-> &__cmsg_data));
	}' unless defined(&CMSG_DATA);
    } else {
	eval 'sub CMSG_DATA {
	    local($cmsg) = @_;
    	    eval q(( ( ($cmsg) + 1)));
	}' unless defined(&CMSG_DATA);
    }
    eval 'sub CMSG_NXTHDR {
        local($mhdr, $cmsg) = @_;
	    eval q( &__cmsg_nxthdr ($mhdr, $cmsg));
    }' unless defined(&CMSG_NXTHDR);
    eval 'sub CMSG_FIRSTHDR {
        local($mhdr) = @_;
	    eval q(( -> &msg_controllen >=  &sizeof ? -> &msg_control :  &NULL));
    }' unless defined(&CMSG_FIRSTHDR);
    unless(defined(&_EXTERN_INLINE)) {
	eval 'sub _EXTERN_INLINE () { &extern  &__inline;}' unless defined(&_EXTERN_INLINE);
    }
    eval 'sub SCM_RIGHTS () { &SCM_RIGHTS;}' unless defined(&SCM_RIGHTS);
    require 'asm/sockios.ph';
    eval 'sub SOL_SOCKET () {0xffff;}' unless defined(&SOL_SOCKET);
    eval 'sub SO_DEBUG () {0x0001;}' unless defined(&SO_DEBUG);
    eval 'sub SO_REUSEADDR () {0x0004;}' unless defined(&SO_REUSEADDR);
    eval 'sub SO_KEEPALIVE () {0x0008;}' unless defined(&SO_KEEPALIVE);
    eval 'sub SO_DONTROUTE () {0x0010;}' unless defined(&SO_DONTROUTE);
    eval 'sub SO_BROADCAST () {0x0020;}' unless defined(&SO_BROADCAST);
    eval 'sub SO_LINGER () {0x0080;}' unless defined(&SO_LINGER);
    eval 'sub SO_OOBINLINE () {0x0100;}' unless defined(&SO_OOBINLINE);
    if(0) {
    }
    eval 'sub SO_TYPE () {0x1008;}' unless defined(&SO_TYPE);
    eval 'sub SO_STYLE () { &SO_TYPE;}' unless defined(&SO_STYLE);
    eval 'sub SO_ERROR () {0x1007;}' unless defined(&SO_ERROR);
    eval 'sub SO_SNDBUF () {0x1001;}' unless defined(&SO_SNDBUF);
    eval 'sub SO_RCVBUF () {0x1002;}' unless defined(&SO_RCVBUF);
    eval 'sub SO_SNDLOWAT () {0x1003;}' unless defined(&SO_SNDLOWAT);
    eval 'sub SO_RCVLOWAT () {0x1004;}' unless defined(&SO_RCVLOWAT);
    eval 'sub SO_SNDTIMEO () {0x1005;}' unless defined(&SO_SNDTIMEO);
    eval 'sub SO_RCVTIMEO () {0x1006;}' unless defined(&SO_RCVTIMEO);
    eval 'sub SO_NO_CHECK () {11;}' unless defined(&SO_NO_CHECK);
    eval 'sub SO_PRIORITY () {12;}' unless defined(&SO_PRIORITY);
    eval 'sub SO_BSDCOMPAT () {14;}' unless defined(&SO_BSDCOMPAT);
    eval 'sub SO_PASSCRED () {17;}' unless defined(&SO_PASSCRED);
    eval 'sub SO_PEERCRED () {18;}' unless defined(&SO_PEERCRED);
    eval 'sub SO_SECURITY_AUTHENTICATION () {22;}' unless defined(&SO_SECURITY_AUTHENTICATION);
    eval 'sub SO_SECURITY_ENCRYPTION_TRANSPORT () {23;}' unless defined(&SO_SECURITY_ENCRYPTION_TRANSPORT);
    eval 'sub SO_SECURITY_ENCRYPTION_NETWORK () {24;}' unless defined(&SO_SECURITY_ENCRYPTION_NETWORK);
    eval 'sub SO_BINDTODEVICE () {25;}' unless defined(&SO_BINDTODEVICE);
    eval 'sub SO_ATTACH_FILTER () {26;}' unless defined(&SO_ATTACH_FILTER);
    eval 'sub SO_DETACH_FILTER () {27;}' unless defined(&SO_DETACH_FILTER);
    eval 'sub SOCK_DGRAM () {1;}' unless defined(&SOCK_DGRAM);
    eval 'sub SOCK_STREAM () {2;}' unless defined(&SOCK_STREAM);
    eval 'sub SOCK_RAW () {3;}' unless defined(&SOCK_RAW);
    eval 'sub SOCK_RDM () {4;}' unless defined(&SOCK_RDM);
    eval 'sub SOCK_SEQPACKET () {5;}' unless defined(&SOCK_SEQPACKET);
    eval 'sub SOCK_PACKET () {10;}' unless defined(&SOCK_PACKET);
}
1;
